/* 2oo4 Michal 'GiM' Spadlinski <gim at skrzynka dot pl>
 *
 * Simple program that:
 * - sets LC_ALL locale to pl_PL
 * - does fork() and executes ls -l /
 * - sets LC_ALL to C
 * - one more fork and ls -l /
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>

char f[1024];

char *findit(char *name)
{
	char *p, *k, *orig;
	struct stat st;
	
	p = getenv("PATH");
	if (!p) return NULL;

	orig = p = strdup(getenv("PATH"));
	while ( (k = strchr(orig, ':')) != NULL)
	{
		strcpy(f, p);
		f[strlen(p)]='/';
		f[strlen(p)+1]='\0';
		strcat(f, name);
		if (lstat(f, &st) != -1)
			if ((st.st_mode)&(0111))
				return f;
		p = k+1;
		*k = ' ';
	}
	free(orig);

	return name;
}

int main(int argc, char **argv, char **envp)
{
	int cpid, st;
	char *margv[4];

	margv[0] = NULL;
	margv[1] = "-l";
	margv[2] = "/";
	margv[3] = NULL;

	/*setenv("LANG", "pl_PL", 1);*/
	putenv("LANG=pl_PL");
	printf("LANG set to: %s\n", getenv("LANG"));
	/*fflush(stdout);*/

	if ((cpid = fork()) == -1)
	{
		perror("fork() failed");
		return -1;
	}
	
	if (!cpid)
	{
		if (execlp("ls", "ls", "-l", "/", NULL) == -1)
			perror("execlp() failed");
		return 0;
	} else {
		if (waitpid(cpid, &st, 0) == -1)
			perror("waitpid()");
	}

	/*setenv("LANG", "C", 1);*/
	putenv("LANG=C");
	printf("LANG set to: %s\n", getenv("LANG"));
	/*fflush(stdout);*/
	
	errno = 0;
	if ((cpid = fork()) == -1)
	{
		perror("fork() failed");
		return -1;
	}
	
	if (!cpid)
	{
		margv[0] = findit("ls");
		if (execve(margv[0], margv, envp) == -1)
			perror("execve() failed");
		return 0;
	} else {
		if (waitpid(cpid, &st, 0) == -1)
			perror("waitpid()");
	}

	return 0;
}
